Index: /pjproject/branches/symbian/pjsip/src/pjsip/sip_transport.c
===================================================================
--- /pjproject/branches/symbian/pjsip/src/pjsip/sip_transport.c	(revision 788)
+++ /pjproject/branches/symbian/pjsip/src/pjsip/sip_transport.c	(revision 789)
@@ -233,5 +233,5 @@
 	return PJ_ENOMEM;
 
-    tdata = pj_pool_zalloc(pool, sizeof(pjsip_tx_data));
+    tdata = (pjsip_tx_data*) pj_pool_zalloc(pool, sizeof(pjsip_tx_data));
     tdata->pool = pool;
     tdata->mgr = mgr;
@@ -314,5 +314,5 @@
     int len;
 
-    cseq = pjsip_msg_find_hdr(msg, PJSIP_H_CSEQ, NULL);
+    cseq = (pjsip_cseq_hdr*) pjsip_msg_find_hdr(msg, PJSIP_H_CSEQ, NULL);
     PJ_ASSERT_RETURN(cseq != NULL, "INVALID MSG");
 
@@ -336,5 +336,5 @@
     }
 
-    info = pj_pool_alloc(pool, len+1);
+    info = (char*) pj_pool_alloc(pool, len+1);
     pj_memcpy(info, info_buf, len+1);
 
@@ -392,5 +392,5 @@
 				    pj_ssize_t size)
 {
-    pjsip_tx_data *tdata = token;
+    pjsip_tx_data *tdata = (pjsip_tx_data *) token;
 
     PJ_UNUSED_ARG(transport);
@@ -417,5 +417,5 @@
     /* Allocate buffer if necessary. */
     if (tdata->buf.start == NULL) {
-	tdata->buf.start = pj_pool_alloc( tdata->pool, PJSIP_MAX_PKT_LEN);
+	tdata->buf.start = (char*)pj_pool_alloc( tdata->pool, PJSIP_MAX_PKT_LEN);
 	tdata->buf.cur = tdata->buf.start;
 	tdata->buf.end = tdata->buf.start + PJSIP_MAX_PKT_LEN;
@@ -510,5 +510,5 @@
 				    struct pj_timer_entry *entry)
 {
-    pjsip_transport *tp = entry->user_data;
+    pjsip_transport *tp = (pjsip_transport *) entry->user_data;
     pj_assert(tp != NULL);
 
@@ -725,5 +725,5 @@
 
     /* Create and initialize transport manager. */
-    mgr = pj_pool_zalloc(pool, sizeof(*mgr));
+    mgr = (pjsip_tpmgr *) pj_pool_zalloc(pool, sizeof(*mgr));
     mgr->endpt = endpt;
     mgr->on_rx_msg = rx_cb;
@@ -771,5 +771,5 @@
 	pjsip_transport *transport;
 	
-	transport = pj_hash_this(mgr->table, itr);
+	transport = (pjsip_transport*) pj_hash_this(mgr->table, itr);
 
 	next = pj_hash_next(mgr->table, itr);
@@ -909,5 +909,5 @@
 	    hdr = (pjsip_hdr*)rdata->msg_info.via->next;
 	    if (hdr != &msg->hdr) {
-		hdr = pjsip_msg_find_hdr(msg, PJSIP_H_VIA, hdr);
+		hdr = (pjsip_hdr*)pjsip_msg_find_hdr(msg, PJSIP_H_VIA, hdr);
 		if (hdr) {
 		    mgr->on_rx_msg(mgr->endpt, PJSIP_EMULTIPLEVIA, rdata);
@@ -964,5 +964,5 @@
     pj_memcpy(&key.addr, remote, addr_len);
 
-    transport = pj_hash_get(mgr->table, &key, key_len, NULL);
+    transport = (pjsip_transport*)pj_hash_get(mgr->table, &key, key_len, NULL);
     if (transport == NULL) {
 	unsigned flag = pjsip_transport_get_flag_from_type(type);
@@ -977,5 +977,6 @@
 	    pj_memset(addr, 0, sizeof(pj_sockaddr_in));
 	    key_len = sizeof(key.type) + sizeof(pj_sockaddr_in);
-	    transport = pj_hash_get(mgr->table, &key, key_len, NULL);
+	    transport = (pjsip_transport*)
+			pj_hash_get(mgr->table, &key, key_len, NULL);
 	}
 	/* For datagram INET transports, try lookup with zero address.
@@ -990,5 +991,6 @@
 
 	    key_len = sizeof(key.type) + sizeof(pj_sockaddr_in);
-	    transport = pj_hash_get(mgr->table, &key, key_len, NULL);
+	    transport = (pjsip_transport*)
+			pj_hash_get(mgr->table, &key, key_len, NULL);
 	}
     }
@@ -1023,5 +1025,6 @@
     /* Request factory to create transport. */
     status = factory->create_transport(factory, mgr, mgr->endpt,
-				       remote, addr_len, tp);
+				       (const pj_sockaddr *)remote, 
+				       addr_len, tp);
     if (status == PJ_SUCCESS) {
 	PJ_ASSERT_ON_FAIL(tp!=NULL, 
@@ -1054,5 +1057,5 @@
 
 	do {
-	    pjsip_transport *t = pj_hash_this(mgr->table, itr);
+	    pjsip_transport *t = (pjsip_transport *) pj_hash_this(mgr->table, itr);
 
 	    PJ_LOG(3, (THIS_FILE, "  %s %s (refcnt=%d)", 
Index: /pjproject/branches/symbian/pjsip/src/pjsip/sip_transport_loop.c
===================================================================
--- /pjproject/branches/symbian/pjsip/src/pjsip/sip_transport_loop.c	(revision 788)
+++ /pjproject/branches/symbian/pjsip/src/pjsip/sip_transport_loop.c	(revision 789)
@@ -78,5 +78,5 @@
 	return NULL;
 
-    pkt = pj_pool_zalloc(pool, sizeof(struct recv_list));
+    pkt = (struct recv_list *) pj_pool_zalloc(pool, sizeof(struct recv_list));
 
     /* Initialize rdata. */
@@ -120,5 +120,6 @@
     pjsip_tx_data_add_ref(tdata);
     pj_lock_acquire(tdata->lock);
-    sent_status = pj_pool_alloc(tdata->pool, sizeof(struct send_list));
+    sent_status = (struct send_list *)
+		  pj_pool_alloc(tdata->pool, sizeof(struct send_list));
     pj_lock_release(tdata->lock);
 
@@ -253,5 +254,5 @@
 static int loop_transport_worker_thread(void *arg)
 {
-    struct loop_transport *loop = arg;
+    struct loop_transport *loop = (struct loop_transport *) arg;
     struct recv_list r;
     struct send_list s;
@@ -356,5 +357,6 @@
 
     /* Create the loop structure. */
-    loop = pj_pool_zalloc(pool, sizeof(struct loop_transport));
+    loop = (struct loop_transport*) 
+	   pj_pool_zalloc(pool, sizeof(struct loop_transport));
     
     /* Initialize transport properties. */
Index: /pjproject/branches/symbian/pjsip/src/pjsip/sip_transport_udp.c
===================================================================
--- /pjproject/branches/symbian/pjsip/src/pjsip/sip_transport_udp.c	(revision 788)
+++ /pjproject/branches/symbian/pjsip/src/pjsip/sip_transport_udp.c	(revision 789)
@@ -17,5 +17,5 @@
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
  */
-#include <pjsip/sip_transport.h>
+#include <pjsip/sip_transport_udp.h>
 #include <pjsip/sip_endpoint.h>
 #include <pjsip/sip_errno.h>
@@ -82,5 +82,5 @@
     pj_pool_reset(pool);
 
-    rdata = pj_pool_zalloc(pool, sizeof(pjsip_rx_data));
+    rdata = (pjsip_rx_data*) pj_pool_zalloc(pool, sizeof(pjsip_rx_data));
 
     /* Init tp_info part. */
@@ -261,5 +261,5 @@
 				   pj_ssize_t bytes_sent)
 {
-    struct udp_transport *tp = pj_ioqueue_get_user_data(key);
+    struct udp_transport *tp = (struct udp_transport *) pj_ioqueue_get_user_data(key);
     pjsip_tx_data_op_key *tdata_op_key = (pjsip_tx_data_op_key*)op_key;
 
@@ -337,6 +337,8 @@
 
     /* Unregister from ioqueue. */
-    if (tp->key)
+    if (tp->key) {
 	pj_ioqueue_unregister(tp->key);
+	tp->sock = PJ_INVALID_SOCKET;
+    }
 
     /* Close socket. */
@@ -425,5 +427,6 @@
 
     /* Create the UDP transport object. */
-    tp = pj_pool_zalloc(pool, sizeof(struct udp_transport));
+    tp = (struct udp_transport*) 
+	 pj_pool_zalloc(pool, sizeof(struct udp_transport));
 
     /* Save pool. */
@@ -474,5 +477,5 @@
 
     /* Transport info. */
-    tp->base.info = pj_pool_alloc(pool, 80);
+    tp->base.info = (char*) pj_pool_alloc(pool, 80);
     pj_ansi_sprintf( 
 	tp->base.info, "udp %s:%d [published as %s:%d]",
@@ -519,5 +522,6 @@
     /* Create rdata and put it in the array. */
     tp->rdata_cnt = 0;
-    tp->rdata = pj_pool_calloc(tp->base.pool, async_cnt, 
+    tp->rdata = (pjsip_rx_data**)
+	        pj_pool_calloc(tp->base.pool, async_cnt, 
 			       sizeof(pjsip_rx_data*));
     for (i=0; i<async_cnt; ++i) {
@@ -553,4 +557,5 @@
 	} else if (status != PJ_EPENDING) {
 	    /* Error! */
+	    pj_atomic_dec(tp->base.ref_cnt);
 	    pjsip_transport_unregister(tp->base.tpmgr, &tp->base);
 	    return status;
Index: /pjproject/branches/symbian/pjsip/src/pjsip/sip_ua_layer.c
===================================================================
--- /pjproject/branches/symbian/pjsip/src/pjsip/sip_ua_layer.c	(revision 788)
+++ /pjproject/branches/symbian/pjsip/src/pjsip/sip_ua_layer.c	(revision 789)
@@ -166,5 +166,5 @@
 
     /* Get the dialog where this transaction belongs. */
-    dlg = tsx->mod_data[mod_ua.mod.id];
+    dlg = (pjsip_dialog*) tsx->mod_data[mod_ua.mod.id];
     
     /* If dialog instance has gone, it could mean that the dialog
@@ -245,5 +245,5 @@
 
     set_key->slen = call_id->slen + local_tag->slen + 1;
-    set_key->ptr = pj_pool_alloc(pool, set_key->slen);
+    set_key->ptr = (char*) pj_pool_alloc(pool, set_key->slen);
     pj_assert(set_key->ptr != NULL);
 
@@ -268,5 +268,6 @@
 	return set;
     } else {
-	set = pj_pool_alloc(mod_ua.pool, sizeof(struct dlg_set));
+	set = (struct dlg_set *) 
+	      pj_pool_alloc(mod_ua.pool, sizeof(struct dlg_set));
 	return set;
     }
@@ -299,5 +300,6 @@
 	struct dlg_set *dlg_set;
 
-	dlg_set = pj_hash_get( mod_ua.dlg_table, dlg->local.info->tag.ptr, 
+	dlg_set = (struct dlg_set *)
+		  pj_hash_get( mod_ua.dlg_table, dlg->local.info->tag.ptr, 
 			       dlg->local.info->tag.slen,
 			       &dlg->local.tag_hval);
@@ -367,5 +369,5 @@
 
     /* Find this dialog from the dialog set. */
-    dlg_set = dlg->dlg_set;
+    dlg_set = (struct dlg_set *) dlg->dlg_set;
     d = dlg_set->dlg_list.next;
     while (d != (pjsip_dialog*)&dlg_set->dlg_list && d != dlg) {
@@ -401,10 +403,10 @@
 PJ_DEF(pjsip_dialog*) pjsip_rdata_get_dlg( pjsip_rx_data *rdata )
 {
-    return rdata->endpt_info.mod_data[mod_ua.mod.id];
+    return (pjsip_dialog*) rdata->endpt_info.mod_data[mod_ua.mod.id];
 }
 
 PJ_DEF(pjsip_dialog*) pjsip_tsx_get_dlg( pjsip_transaction *tsx )
 {
-    return tsx->mod_data[mod_ua.mod.id];
+    return (pjsip_dialog*) tsx->mod_data[mod_ua.mod.id];
 }
 
@@ -442,5 +444,5 @@
 	/* We should find the dialog attached to the INVITE transaction */
 	if (tsx) {
-	    dlg = tsx->mod_data[mod_ua.mod.id];
+	    dlg = (pjsip_dialog*) tsx->mod_data[mod_ua.mod.id];
 	    pj_mutex_unlock(tsx->mutex);
 
@@ -448,5 +450,5 @@
 	     * (e.g. during debugging where initially there is a dialog)
 	     */
-	    return dlg ? dlg->dlg_set : NULL;
+	    return dlg ? (struct dlg_set *)dlg->dlg_set : NULL;
 
 	} else {
@@ -465,5 +467,6 @@
 
 	/* Lookup the dialog set. */
-	dlg_set = pj_hash_get(mod_ua.dlg_table, tag->ptr, tag->slen, NULL);
+	dlg_set = (struct dlg_set *) 
+		  pj_hash_get(mod_ua.dlg_table, tag->ptr, tag->slen, NULL);
 	return dlg_set;
     }
@@ -594,5 +597,5 @@
 
 	/* Get the dialog set. */
-	dlg_set = dlg->dlg_set;
+	dlg_set = (struct dlg_set *)dlg->dlg_set;
 
 	/* Even if transaction is found and (candidate) dialog has been 
@@ -622,5 +625,6 @@
 
 	/* Get the dialog set. */
-	dlg_set = pj_hash_get(mod_ua.dlg_table, 
+	dlg_set = (struct dlg_set *)
+		  pj_hash_get(mod_ua.dlg_table, 
 			      rdata->msg_info.from->tag.ptr,
 			      rdata->msg_info.from->tag.slen,
@@ -801,5 +805,5 @@
 	    const char *title;
 
-	    dlg_set = pj_hash_this(mod_ua.dlg_table, it);
+	    dlg_set = (struct dlg_set *) pj_hash_this(mod_ua.dlg_table, it);
 	    if (!dlg_set || pj_list_empty(&dlg_set->dlg_list)) continue;
 
Index: /pjproject/branches/symbian/pjsip/src/pjsip/sip_uri.c
===================================================================
--- /pjproject/branches/symbian/pjsip/src/pjsip/sip_uri.c	(revision 788)
+++ /pjproject/branches/symbian/pjsip/src/pjsip/sip_uri.c	(revision 789)
@@ -61,5 +61,6 @@
     pj_list_init(dst_list);
     while (p != src_list) {
-	pjsip_param *new_param = pj_pool_alloc(pool, sizeof(pjsip_param));
+	pjsip_param *new_param = (pjsip_param *)
+				 pj_pool_alloc(pool, sizeof(pjsip_param));
 	pj_strdup(pool, &new_param->name, &p->name);
 	pj_strdup(pool, &new_param->value, &p->value);
@@ -78,5 +79,6 @@
     pj_list_init(dst_list);
     while (p != src_list) {
-	pjsip_param *new_param = pj_pool_alloc(pool, sizeof(pjsip_param));
+	pjsip_param *new_param = (pjsip_param *) 
+				 pj_pool_alloc(pool, sizeof(pjsip_param));
 	new_param->name = p->name;
 	new_param->value = p->value;
@@ -156,29 +158,39 @@
 				      const pjsip_sip_uri *rhs);
 
+typedef const pj_str_t* (*FGETSCHEME)(const void *uri);
+typedef void* (*FGETURI)(void *uri);
+typedef pj_ssize_t (*FPRINT)(pjsip_uri_context_e context,
+			     const void *uri, 
+			     char *buf, pj_size_t size);
+typedef pj_status_t (*FCOMPARE)(pjsip_uri_context_e context, 
+			        const void *uri1, const void *uri2);
+typedef void *(*FCLONE)(pj_pool_t *pool, const void *uri);
+
+
 static pjsip_uri_vptr sip_url_vptr = 
 {
-    HAPPY_FLAG &pjsip_url_get_scheme,
-    HAPPY_FLAG &pjsip_get_uri,
-    HAPPY_FLAG &pjsip_url_print,
-    HAPPY_FLAG &pjsip_url_compare,
-    HAPPY_FLAG &pjsip_url_clone
+    (FGETSCHEME)&pjsip_url_get_scheme,
+    (FGETURI)	&pjsip_get_uri,
+    (FPRINT)	&pjsip_url_print,
+    (FCOMPARE)	&pjsip_url_compare,
+    (FCLONE)	&pjsip_url_clone
 };
 
 static pjsip_uri_vptr sips_url_vptr = 
 {
-    HAPPY_FLAG &pjsips_url_get_scheme,
-    HAPPY_FLAG &pjsip_get_uri,
-    HAPPY_FLAG &pjsip_url_print,
-    HAPPY_FLAG &pjsip_url_compare,
-    HAPPY_FLAG &pjsip_url_clone
+    (FGETSCHEME)&pjsips_url_get_scheme,
+    (FGETURI)	&pjsip_get_uri,
+    (FPRINT)	&pjsip_url_print,
+    (FCOMPARE)	&pjsip_url_compare,
+    (FCLONE)	&pjsip_url_clone
 };
 
 static pjsip_uri_vptr name_addr_vptr = 
 {
-    HAPPY_FLAG &pjsip_name_addr_get_scheme,
-    HAPPY_FLAG &pjsip_name_addr_get_uri,
-    HAPPY_FLAG &pjsip_name_addr_print,
-    HAPPY_FLAG &pjsip_name_addr_compare,
-    HAPPY_FLAG &pjsip_name_addr_clone
+    (FGETSCHEME)&pjsip_name_addr_get_scheme,
+    (FGETURI)	&pjsip_name_addr_get_uri,
+    (FPRINT)	&pjsip_name_addr_print,
+    (FCOMPARE)	&pjsip_name_addr_compare,
+    (FCLONE)	&pjsip_name_addr_clone
 };
 
@@ -216,5 +228,5 @@
 PJ_DEF(pjsip_sip_uri*) pjsip_sip_uri_create( pj_pool_t *pool, int secure )
 {
-    pjsip_sip_uri *url = pj_pool_alloc(pool, sizeof(pjsip_sip_uri));
+    pjsip_sip_uri *url = (pjsip_sip_uri *)pj_pool_alloc(pool, sizeof(pjsip_sip_uri));
     pjsip_sip_uri_init(url, secure);
     return url;
@@ -485,5 +497,5 @@
 static pjsip_sip_uri* pjsip_url_clone(pj_pool_t *pool, const pjsip_sip_uri *rhs)
 {
-    pjsip_sip_uri *url = pj_pool_alloc(pool, sizeof(pjsip_sip_uri));
+    pjsip_sip_uri *url = (pjsip_sip_uri *)pj_pool_alloc(pool, sizeof(pjsip_sip_uri));
     if (!url)
 	return NULL;
@@ -509,5 +521,5 @@
 PJ_DEF(pjsip_name_addr*) pjsip_name_addr_create(pj_pool_t *pool)
 {
-    pjsip_name_addr *name_addr = pj_pool_alloc(pool, sizeof(pjsip_name_addr));
+    pjsip_name_addr *name_addr = (pjsip_name_addr *)pj_pool_alloc(pool, sizeof(pjsip_name_addr));
     pjsip_name_addr_init(name_addr);
     return name_addr;
@@ -552,5 +564,5 @@
 {
     pj_strdup( pool, &dst->display, &src->display);
-    dst->uri = pjsip_uri_clone(pool, src->uri);
+    dst->uri = (pjsip_uri*)pjsip_uri_clone(pool, src->uri);
 }
 
@@ -558,5 +570,5 @@
 					       const pjsip_name_addr *rhs)
 {
-    pjsip_name_addr *addr = pj_pool_alloc(pool, sizeof(pjsip_name_addr));
+    pjsip_name_addr *addr = (pjsip_name_addr *)pj_pool_alloc(pool, sizeof(pjsip_name_addr));
     if (!addr)
 	return NULL;
Index: /pjproject/branches/symbian/pjsip/src/pjsip/sip_util.c
===================================================================
--- /pjproject/branches/symbian/pjsip/src/pjsip/sip_util.c	(revision 788)
+++ /pjproject/branches/symbian/pjsip/src/pjsip/sip_util.c	(revision 789)
@@ -85,5 +85,5 @@
     endpt_hdr = pjsip_endpt_get_request_headers(endpt)->next;
     while (endpt_hdr != pjsip_endpt_get_request_headers(endpt)) {
-	pjsip_hdr *hdr = pjsip_hdr_shallow_clone(tdata->pool, endpt_hdr);
+	pjsip_hdr *hdr = (pjsip_hdr *)pjsip_hdr_shallow_clone(tdata->pool, endpt_hdr);
 	pjsip_msg_add_hdr( tdata->msg, hdr );
 	endpt_hdr = endpt_hdr->next;
@@ -93,24 +93,24 @@
     if (param_from->tag.slen == 0)
 	pj_create_unique_string(tdata->pool, &param_from->tag);
-    pjsip_msg_add_hdr(msg, (void*)param_from);
+    pjsip_msg_add_hdr(msg, (pjsip_hdr*)param_from);
 
     /* Add To header. */
-    pjsip_msg_add_hdr(msg, (void*)param_to);
+    pjsip_msg_add_hdr(msg, (pjsip_hdr*)param_to);
 
     /* Add Contact header. */
     if (param_contact) {
-	pjsip_msg_add_hdr(msg, (void*)param_contact);
+	pjsip_msg_add_hdr(msg, (pjsip_hdr*)param_contact);
     }
 
     /* Add Call-ID header. */
-    pjsip_msg_add_hdr(msg, (void*)param_call_id);
+    pjsip_msg_add_hdr(msg, (pjsip_hdr*)param_call_id);
 
     /* Add CSeq header. */
-    pjsip_msg_add_hdr(msg, (void*)param_cseq);
+    pjsip_msg_add_hdr(msg, (pjsip_hdr*)param_cseq);
 
     /* Add a blank Via header in the front of the message. */
     via = pjsip_via_hdr_create(tdata->pool);
     via->rport_param = 0;
-    pjsip_msg_insert_first_hdr(msg, (void*)via);
+    pjsip_msg_insert_first_hdr(msg, (pjsip_hdr*)via);
 
     /* Add header params as request headers */
@@ -135,5 +135,5 @@
     /* Create message body. */
     if (param_text) {
-	body = pj_pool_calloc(tdata->pool, 1, sizeof(pjsip_msg_body));
+	body = (pjsip_msg_body*) pj_pool_calloc(tdata->pool, 1, sizeof(pjsip_msg_body));
 	body->content_type.type = str_TEXT;
 	body->content_type.subtype = str_PLAIN;
@@ -297,14 +297,14 @@
     PJ_TRY {
 	/* Duplicate target URI and headers. */
-	target = pjsip_uri_clone(tdata->pool, param_target);
-	from = pjsip_hdr_clone(tdata->pool, param_from);
+	target = (pjsip_uri*) pjsip_uri_clone(tdata->pool, param_target);
+	from = (pjsip_fromto_hdr*) pjsip_hdr_clone(tdata->pool, param_from);
 	pjsip_fromto_hdr_set_from(from);
-	to = pjsip_hdr_clone(tdata->pool, param_to);
+	to = (pjsip_fromto_hdr*)pjsip_hdr_clone(tdata->pool, param_to);
 	pjsip_fromto_hdr_set_to(to);
 	if (param_contact)
-	    contact = pjsip_hdr_clone(tdata->pool, param_contact);
+	    contact = (pjsip_contact_hdr*) pjsip_hdr_clone(tdata->pool, param_contact);
 	else
 	    contact = NULL;
-	call_id = pjsip_hdr_clone(tdata->pool, param_call_id);
+	call_id = (pjsip_cid_hdr*) pjsip_hdr_clone(tdata->pool, param_call_id);
 	cseq = pjsip_cseq_hdr_create(tdata->pool);
 	if (param_cseq >= 0)
@@ -386,8 +386,8 @@
     via = rdata->msg_info.via;
     while (via) {
-	pjsip_msg_add_hdr( msg, pjsip_hdr_clone(tdata->pool, via));
+	pjsip_msg_add_hdr( msg, (pjsip_hdr*)pjsip_hdr_clone(tdata->pool, via));
 	via = via->next;
 	if (via != (void*)&req_msg->hdr)
-	    via = pjsip_msg_find_hdr(req_msg, PJSIP_H_VIA, via);
+	    via = (pjsip_via_hdr*) pjsip_msg_find_hdr(req_msg, PJSIP_H_VIA, via);
 	else
 	    break;
@@ -395,10 +395,10 @@
 
     /* Copy all Record-Route headers, in order. */
-    rr = pjsip_msg_find_hdr(req_msg, PJSIP_H_RECORD_ROUTE, NULL);
+    rr = (pjsip_route_hdr*) pjsip_msg_find_hdr(req_msg, PJSIP_H_RECORD_ROUTE, NULL);
     while (rr) {
-	pjsip_msg_add_hdr(msg, pjsip_hdr_clone(tdata->pool, rr));
+	pjsip_msg_add_hdr(msg, (pjsip_hdr*) pjsip_hdr_clone(tdata->pool, rr));
 	rr = rr->next;
 	if (rr != (void*)&req_msg->hdr)
-	    rr = pjsip_msg_find_hdr(req_msg, PJSIP_H_RECORD_ROUTE, rr);
+	    rr = (pjsip_route_hdr*) pjsip_msg_find_hdr(req_msg, PJSIP_H_RECORD_ROUTE, rr);
 	else
 	    break;
@@ -406,17 +406,17 @@
 
     /* Copy Call-ID header. */
-    hdr = pjsip_msg_find_hdr( req_msg, PJSIP_H_CALL_ID, NULL);
-    pjsip_msg_add_hdr(msg, pjsip_hdr_clone(tdata->pool, hdr));
+    hdr = (pjsip_hdr*) pjsip_msg_find_hdr( req_msg, PJSIP_H_CALL_ID, NULL);
+    pjsip_msg_add_hdr(msg, (pjsip_hdr*) pjsip_hdr_clone(tdata->pool, hdr));
 
     /* Copy From header. */
-    hdr = pjsip_hdr_clone(tdata->pool, rdata->msg_info.from);
+    hdr = (pjsip_hdr*) pjsip_hdr_clone(tdata->pool, rdata->msg_info.from);
     pjsip_msg_add_hdr( msg, hdr);
 
     /* Copy To header. */
-    hdr = pjsip_hdr_clone(tdata->pool, rdata->msg_info.to);
+    hdr = (pjsip_hdr*) pjsip_hdr_clone(tdata->pool, rdata->msg_info.to);
     pjsip_msg_add_hdr( msg, hdr);
 
     /* Copy CSeq header. */
-    hdr = pjsip_hdr_clone(tdata->pool, rdata->msg_info.cseq);
+    hdr = (pjsip_hdr*) pjsip_hdr_clone(tdata->pool, rdata->msg_info.cseq);
     pjsip_msg_add_hdr( msg, hdr);
 
@@ -495,21 +495,21 @@
 
     /* Clear Via headers in the new request. */
-    while ((via=pjsip_msg_find_hdr(ack->msg, PJSIP_H_VIA, NULL)) != NULL)
+    while ((via=(pjsip_hdr*)pjsip_msg_find_hdr(ack->msg, PJSIP_H_VIA, NULL)) != NULL)
 	pj_list_erase(via);
 
     /* Must contain single Via, just as the original INVITE. */
-    hdr = pjsip_msg_find_hdr( invite_msg, PJSIP_H_VIA, NULL);
-    pjsip_msg_insert_first_hdr( ack->msg, pjsip_hdr_clone(ack->pool,hdr) );
+    hdr = (pjsip_hdr*) pjsip_msg_find_hdr( invite_msg, PJSIP_H_VIA, NULL);
+    pjsip_msg_insert_first_hdr( ack->msg, (pjsip_hdr*) pjsip_hdr_clone(ack->pool,hdr) );
 
     /* If the original INVITE has Route headers, those header fields MUST 
      * appear in the ACK.
      */
-    hdr = pjsip_msg_find_hdr( invite_msg, PJSIP_H_ROUTE, NULL);
+    hdr = (pjsip_hdr*) pjsip_msg_find_hdr( invite_msg, PJSIP_H_ROUTE, NULL);
     while (hdr != NULL) {
-	pjsip_msg_add_hdr( ack->msg, pjsip_hdr_clone(ack->pool, hdr) );
+	pjsip_msg_add_hdr( ack->msg, (pjsip_hdr*) pjsip_hdr_clone(ack->pool, hdr) );
 	hdr = hdr->next;
 	if (hdr == &invite_msg->hdr)
 	    break;
-	hdr = pjsip_msg_find_hdr( invite_msg, PJSIP_H_ROUTE, hdr);
+	hdr = (pjsip_hdr*) pjsip_msg_find_hdr( invite_msg, PJSIP_H_ROUTE, hdr);
     }
 
@@ -579,5 +579,5 @@
 
     /* Clear Via headers in the new request. */
-    while ((via=pjsip_msg_find_hdr(cancel_tdata->msg, PJSIP_H_VIA, NULL)) != NULL)
+    while ((via=(pjsip_hdr*)pjsip_msg_find_hdr(cancel_tdata->msg, PJSIP_H_VIA, NULL)) != NULL)
 	pj_list_erase(via);
 
@@ -586,8 +586,8 @@
      * request being cancelled. 
      */
-    hdr = pjsip_msg_find_hdr(req_tdata->msg, PJSIP_H_VIA, NULL);
+    hdr = (pjsip_hdr*) pjsip_msg_find_hdr(req_tdata->msg, PJSIP_H_VIA, NULL);
     if (hdr) {
 	pjsip_msg_insert_first_hdr(cancel_tdata->msg, 
-				   pjsip_hdr_clone(cancel_tdata->pool, hdr));
+				   (pjsip_hdr*) pjsip_hdr_clone(cancel_tdata->pool, hdr));
     }
 
@@ -596,11 +596,11 @@
      * Copy "Route" header from the request.
      */
-    hdr = pjsip_msg_find_hdr(req_tdata->msg, PJSIP_H_ROUTE, NULL);
+    hdr = (pjsip_hdr*) pjsip_msg_find_hdr(req_tdata->msg, PJSIP_H_ROUTE, NULL);
     while (hdr != NULL) {
 	pjsip_msg_add_hdr(cancel_tdata->msg, 
-			  pjsip_hdr_clone(cancel_tdata->pool, hdr));
+			  (pjsip_hdr*) pjsip_hdr_clone(cancel_tdata->pool, hdr));
 	hdr = hdr->next;
 	if (hdr != &cancel_tdata->msg->hdr)
-	    hdr = pjsip_msg_find_hdr(cancel_tdata->msg, PJSIP_H_ROUTE, hdr);
+	    hdr = (pjsip_hdr*) pjsip_msg_find_hdr(cancel_tdata->msg, PJSIP_H_ROUTE, hdr);
 	else
 	    break;
@@ -642,10 +642,11 @@
      */
     last_route_hdr = first_route_hdr = 
-	pjsip_msg_find_hdr(tdata->msg, PJSIP_H_ROUTE, NULL);
+	(pjsip_route_hdr*) pjsip_msg_find_hdr(tdata->msg, PJSIP_H_ROUTE, NULL);
     if (first_route_hdr) {
 	topmost_route_uri = &first_route_hdr->name_addr;
 	while (last_route_hdr->next != (void*)&tdata->msg->hdr) {
 	    pjsip_route_hdr *hdr;
-	    hdr = pjsip_msg_find_hdr(tdata->msg, PJSIP_H_ROUTE, 
+	    hdr = (pjsip_route_hdr*) 
+		  pjsip_msg_find_hdr(tdata->msg, PJSIP_H_ROUTE, 
                                      last_route_hdr->next);
 	    if (!hdr)
@@ -672,5 +673,5 @@
 	    PJSIP_URI_SCHEME_IS_SIPS(topmost_route_uri))
 	{
-	    const pjsip_sip_uri *url = 
+	    const pjsip_sip_uri *url = (const pjsip_sip_uri *)
 		pjsip_uri_get_uri((void*)topmost_route_uri);
 	    has_lr_param = url->lr_param;
@@ -691,5 +692,6 @@
 	    */
 	} else {
-	    new_request_uri = pjsip_uri_get_uri((void*)topmost_route_uri);
+	    new_request_uri = (const pjsip_uri *) 
+			      pjsip_uri_get_uri((void*)topmost_route_uri);
 	    pj_list_erase(first_route_hdr);
 	    if (first_route_hdr == last_route_hdr)
@@ -758,5 +760,5 @@
 					 pj_ssize_t sent )
 {
-    pjsip_send_state *stateless_data = token;
+    pjsip_send_state *stateless_data = (pjsip_send_state *) token;
 
     PJ_UNUSED_ARG(tdata);
@@ -858,5 +860,6 @@
 	if (via->branch_param.slen == 0) {
 	    pj_str_t tmp;
-	    via->branch_param.ptr = pj_pool_alloc(tdata->pool,
+	    via->branch_param.ptr = (char*)
+				    pj_pool_alloc(tdata->pool,
 						  PJSIP_MAX_BRANCH_LEN);
 	    via->branch_param.slen = PJSIP_MAX_BRANCH_LEN;
@@ -902,5 +905,5 @@
 				  const struct pjsip_server_addresses *addr)
 {
-    pjsip_send_state *stateless_data = token;
+    pjsip_send_state *stateless_data = (pjsip_send_state *) token;
 
     /* Fail on server resolution. */
@@ -950,5 +953,6 @@
 
     /* Keep stateless data. */
-    stateless_data = pj_pool_zalloc(tdata->pool, sizeof(pjsip_send_state));
+    stateless_data = (pjsip_send_state *) 
+		     pj_pool_zalloc(tdata->pool, sizeof(pjsip_send_state));
     stateless_data->token = token;
     stateless_data->endpt = endpt;
@@ -1073,5 +1077,5 @@
 				       pj_ssize_t sent)
 {
-    pjsip_send_state *send_state = token;
+    pjsip_send_state *send_state = (pjsip_send_state *) token;
     pj_bool_t cont = PJ_FALSE;
 
@@ -1093,5 +1097,5 @@
 				       const pjsip_server_addresses *addr )
 {
-    pjsip_send_state *send_state = token;
+    pjsip_send_state *send_state = (pjsip_send_state *) token;
 
     if (status != PJ_SUCCESS) {
@@ -1161,5 +1165,6 @@
 
     /* Create structure to keep the sending state. */
-    send_state = pj_pool_zalloc(tdata->pool, sizeof(pjsip_send_state));
+    send_state = (pjsip_send_state *) 
+		 pj_pool_zalloc(tdata->pool, sizeof(pjsip_send_state));
     send_state->endpt = endpt;
     send_state->tdata = tdata;
@@ -1229,5 +1234,5 @@
 	const pjsip_hdr *hdr = hdr_list->next;
 	while (hdr != hdr_list) {
-	    pjsip_msg_add_hdr( tdata->msg, pjsip_hdr_clone(tdata->pool, hdr) );
+	    pjsip_msg_add_hdr( tdata->msg, (pjsip_hdr*)pjsip_hdr_clone(tdata->pool, hdr) );
 	    hdr = hdr->next;
 	}
Index: /pjproject/branches/symbian/pjsip/src/pjsip/sip_util_statefull.c
===================================================================
--- /pjproject/branches/symbian/pjsip/src/pjsip/sip_util_statefull.c	(revision 788)
+++ /pjproject/branches/symbian/pjsip/src/pjsip/sip_util_statefull.c	(revision 789)
@@ -60,5 +60,5 @@
 	return;
 
-    tsx_data = tsx->mod_data[mod_stateful_util.id];
+    tsx_data = (struct tsx_data *) tsx->mod_data[mod_stateful_util.id];
     if (tsx_data == NULL)
 	return;
@@ -100,5 +100,6 @@
     }
 
-    tsx_data = pj_pool_alloc(tsx->pool, sizeof(struct tsx_data));
+    tsx_data = (struct tsx_data *) 
+	       pj_pool_alloc(tsx->pool, sizeof(struct tsx_data));
     tsx_data->token = token;
     tsx_data->cb = cb;
@@ -142,5 +143,5 @@
 	const pjsip_hdr *hdr = hdr_list->next;
 	while (hdr != hdr_list) {
-	    pjsip_msg_add_hdr( tdata->msg, pjsip_hdr_clone(tdata->pool, hdr) );
+	    pjsip_msg_add_hdr( tdata->msg, (pjsip_hdr*)pjsip_hdr_clone(tdata->pool, hdr) );
 	    hdr = hdr->next;
 	}
Index: /pjproject/branches/symbian/symbian/bld.inf
===================================================================
--- /pjproject/branches/symbian/symbian/bld.inf	(revision 788)
+++ /pjproject/branches/symbian/symbian/bld.inf	(revision 789)
@@ -1,3 +1,9 @@
 prj_mmpfiles
 pjlib.mmp
+pjlib_util.mmp
+pjsip.mmp
+pjsip_simple.mmp
+pjsdp.mmp
+pjsip_ua.mmp
 pjlib_test.mmp
+sipstateless.mmp
Index: /pjproject/branches/symbian/symbian/pjlib.mmp
===================================================================
--- /pjproject/branches/symbian/symbian/pjlib.mmp	(revision 788)
+++ /pjproject/branches/symbian/symbian/pjlib.mmp	(revision 789)
@@ -5,4 +5,6 @@
 
 SOURCEPATH	..\pjlib\src\pj
+
+OPTION		CW -lang c++
 
 MACRO		PJ_M_I386=1
@@ -56,4 +58,6 @@
 
 SYSTEMINCLUDE	..\pjlib\include
+
 SYSTEMINCLUDE	\epoc32\include
 SYSTEMINCLUDE	\epoc32\include\libc
+
Index: /pjproject/branches/symbian/symbian/pjlib_test.mmp
===================================================================
--- /pjproject/branches/symbian/symbian/pjlib_test.mmp	(revision 788)
+++ /pjproject/branches/symbian/symbian/pjlib_test.mmp	(revision 789)
@@ -10,4 +10,5 @@
 MACRO		PJ_IMPORTING
 
+OPTION		CW -lang c++
 
 // Test files
@@ -48,4 +49,5 @@
 
 SYSTEMINCLUDE	..\pjlib\include
+
 SYSTEMINCLUDE	\epoc32\include
 SYSTEMINCLUDE	\epoc32\include\libc
Index: /pjproject/branches/symbian/symbian/pjlib_util.mmp
===================================================================
--- /pjproject/branches/symbian/symbian/pjlib_util.mmp	(revision 789)
+++ /pjproject/branches/symbian/symbian/pjlib_util.mmp	(revision 789)
@@ -0,0 +1,33 @@
+TARGET 		pjlib_util.lib
+TARGETTYPE 	lib
+UID		0x100039CE 0x10004299
+VENDORID	0x70000001
+
+SOURCEPATH	..\pjlib-util\src\pjlib-util
+
+MACRO		PJ_M_I386=1
+MACRO		PJ_SYMBIAN=1
+MACRO		PJ_IMPORTING
+
+OPTION		CW -lang c++
+
+// PJLIB-UTIL files
+
+SOURCE	errno.c
+SOURCE	getopt.c
+SOURCE	md5.c
+SOURCE	scanner.c
+SOURCE	string.c
+SOURCE	stun.c
+SOURCE	stun_client.c
+SOURCE	xml.c
+
+SYSTEMINCLUDE	..\pjlib\include 
+SYSTEMINCLUDE	..\pjlib-util\include
+
+SYSTEMINCLUDE	\epoc32\include
+SYSTEMINCLUDE	\epoc32\include\libc
+
+LIBRARY		pjlib.lib 
+CAPABILITY	None
+
Index: /pjproject/branches/symbian/symbian/pjsdp.mmp
===================================================================
--- /pjproject/branches/symbian/symbian/pjsdp.mmp	(revision 789)
+++ /pjproject/branches/symbian/symbian/pjsdp.mmp	(revision 789)
@@ -0,0 +1,29 @@
+TARGET 		pjsdp.lib
+TARGETTYPE 	lib
+UID		0x100039CE 0x10004299
+VENDORID	0x70000001
+
+SOURCEPATH	..\pjmedia\src\pjmedia
+
+OPTION		CW -lang c++
+
+MACRO		PJ_M_I386=1
+MACRO		PJ_SYMBIAN=1
+MACRO		PJ_EXPORTING
+
+//
+// Platform independent source
+//
+SOURCE		errno.c
+SOURCE		sdp.c
+SOURCE		sdp_cmp.c
+SOURCE		sdp_neg.c
+
+
+SYSTEMINCLUDE	..\pjlib\include 
+SYSTEMINCLUDE	..\pjlib-util\include 
+SYSTEMINCLUDE	..\pjmedia\include
+
+SYSTEMINCLUDE	\epoc32\include
+SYSTEMINCLUDE	\epoc32\include\libc
+
Index: /pjproject/branches/symbian/symbian/pjsip.mmp
===================================================================
--- /pjproject/branches/symbian/symbian/pjsip.mmp	(revision 789)
+++ /pjproject/branches/symbian/symbian/pjsip.mmp	(revision 789)
@@ -0,0 +1,45 @@
+TARGET 		pjsip.lib
+TARGETTYPE 	lib
+UID		0x100039CE 0x10004299
+VENDORID	0x70000001
+
+SOURCEPATH	..\pjsip\src\pjsip
+
+MACRO		PJ_M_I386=1
+MACRO		PJ_SYMBIAN=1
+MACRO		PJ_IMPORTING
+
+OPTION		CW -lang c++
+
+// PJSIP-CORE files
+
+SOURCE	sip_auth_client.c
+SOURCE	sip_auth_msg.c
+SOURCE	sip_auth_parser.c
+SOURCE	sip_auth_server.c
+SOURCE	sip_dialog.c
+SOURCE	sip_endpoint.c
+SOURCE	sip_errno.c
+SOURCE	sip_msg.c
+SOURCE	sip_parser.c
+SOURCE	sip_resolve.c
+SOURCE	sip_tel_uri.c
+SOURCE	sip_transaction.c
+SOURCE	sip_transport.c
+SOURCE	sip_transport_loop.c
+SOURCE	sip_transport_udp.c
+SOURCE	sip_ua_layer.c
+SOURCE	sip_uri.c
+SOURCE	sip_util.c
+SOURCE	sip_util_proxy.c
+SOURCE	sip_util_statefull.c
+
+SYSTEMINCLUDE	..\pjlib\include 
+SYSTEMINCLUDE	..\pjlib-util\include 
+SYSTEMINCLUDE	..\pjsip\include
+
+SYSTEMINCLUDE	\epoc32\include
+SYSTEMINCLUDE	\epoc32\include\libc
+
+CAPABILITY	None
+
Index: /pjproject/branches/symbian/symbian/pjsip_simple.mmp
===================================================================
--- /pjproject/branches/symbian/symbian/pjsip_simple.mmp	(revision 789)
+++ /pjproject/branches/symbian/symbian/pjsip_simple.mmp	(revision 789)
@@ -0,0 +1,33 @@
+TARGET 		pjsip_simple.lib
+TARGETTYPE 	lib
+UID		0x100039CE 0x10004299
+VENDORID	0x70000001
+
+SOURCEPATH	..\pjsip\src\pjsip-simple
+
+MACRO		PJ_M_I386=1
+MACRO		PJ_SYMBIAN=1
+MACRO		PJ_IMPORTING
+
+//OPTION		CW -lang c++
+
+
+// PJSIP-SIMPLE files
+
+SOURCE	errno.c
+SOURCE	evsub.c
+SOURCE	evsub_msg.c
+SOURCE	iscomposing.c
+SOURCE	pidf.c
+SOURCE	presence.c
+SOURCE	xpidf.c
+
+SYSTEMINCLUDE	..\pjlib\include 
+SYSTEMINCLUDE	..\pjlib-util\include 
+SYSTEMINCLUDE	..\pjsip\include
+
+SYSTEMINCLUDE	\epoc32\include
+SYSTEMINCLUDE	\epoc32\include\libc
+
+CAPABILITY	None
+
Index: /pjproject/branches/symbian/symbian/pjsip_ua.mmp
===================================================================
--- /pjproject/branches/symbian/symbian/pjsip_ua.mmp	(revision 789)
+++ /pjproject/branches/symbian/symbian/pjsip_ua.mmp	(revision 789)
@@ -0,0 +1,30 @@
+TARGET 		pjsip_ua.lib
+TARGETTYPE 	lib
+UID		0x100039CE 0x10004299
+VENDORID	0x70000001
+
+SOURCEPATH	..\pjsip\src\pjsip-ua
+
+MACRO		PJ_M_I386=1
+MACRO		PJ_SYMBIAN=1
+MACRO		PJ_IMPORTING
+
+//OPTION		CW -lang c++
+
+
+// PJSIP-SIMPLE files
+
+SOURCE	sip_inv.c
+SOURCE	sip_reg.c
+SOURCE	sip_xfer.c
+
+SYSTEMINCLUDE	..\pjlib\include 
+SYSTEMINCLUDE	..\pjlib-util\include 
+SYSTEMINCLUDE	..\pjsip\include 
+SYSTEMINCLUDE	..\pjmedia\include
+
+SYSTEMINCLUDE	\epoc32\include
+SYSTEMINCLUDE	\epoc32\include\libc
+
+CAPABILITY	None
+
